// Suggested classes for "Survival" program.
// You may wish to use this code and develop it further,
// or you can use your own ideas.
// In either case I think that you should write the program
// for a single creature (circle) using one moving strategy
// e.g. horizontal, left to right and a single food source.
// Then you should make the program more sopisticated with
// 5 creatures, several strategies and many food sources.
//                                                                    F.M.

#include<conio.h>
#include<graphics.h>
#include<iostream.h>

void opengraph();          // function defined in the main program

class point                // base class to locate point x,y
{
protected:
int x,y;
public:
point()            {x=0;y=0;}   // constructor zeroises x,y
// co-ords are input by the user
void input_point   (int xin,int yin)        {x=xin;y=yin;}
};

//...........................................................................

class strategies          // class to calculate where the creature moves to.
{
public: int  stratx,straty;
			 // oldx,oldy are the co-ords of the circle's centre
			 // before its move.
			 // stratx,straty are the co-ords of the circle's
			 // centre after calculating its next move.
protected:
void strategy_1(int oldx,int oldy)
{// simple horizontal movement, left to right
stratx=oldx+50;
straty=oldy;
}
};

//...........................................................................

class input_coords        // class to accept data input by the user.
{
public: int inx,iny;      // co-ordinates of user input
public:
void keyboard();
};

void input_coords::keyboard()
{
gotoxy(20,1);            // position the text on the screen.
cout<< "Please enter the x co-ordinate:  ";
cin >> inx;
gotoxy(20,2);
cout<< "Please enter the y co-ordinate:  ";
cin >> iny;
};

//..........................................................................

class creature : public point, public input_coords, public strategies
		// class creature inherits from 3 other classes.
{
int radius;
public:
creature()          // constructor initialises circle data
{
initialise();
}

void initialise();     // initialisation routine
void centre_coords();  // get the circle's centre co-ordinates
void set_radius();     // get the circle's radius
void hide();           // erase the circle from the screen
void show();           // display the circle on the screen
void move();           // move the circle
void calc_move();      // calculate the co-ordinates for the circle's
		       // next move
void inc_energy();     // increase the circle's energy
void  dec_energy();    // decrease the circle's energy
};

void creature::initialise()
{
centre_coords();
set_radius();
};

void creature::centre_coords()
{
input_coords::keyboard();
point::input_point(inx,iny);
};

void creature::set_radius()      //  sets the size of the circle radius
{
gotoxy(20,3);
cout << "Please enter the radius: ";
cin  >> radius;
};


void creature::hide()
{

};

void creature::show()
{
circle(x,y,radius);
};

void creature::move()
{
};

void creature::calc_move()
{
int oldx,oldy;
oldx=x;oldy=y;
strategies::strategy_1(oldx,oldy);   // circle's position is oldx, oldy
				     // calculate the circle's next move
				     // using strategy_1.
point::input_point(stratx,straty);   // circle's new position is
				     // stratx,straty  and these co-ords are
				     // passed as parameters to class point
				     // which asssigns them to x and y.

};


void creature::inc_energy()
{
};

void creature::dec_energy()
{
};

//...........................................................................

class food: public point
{
public: int x,y,size;     // x,y are co-ords for the start of a line
			  // this point will be the top,left co-ords
			  // of the  X  food symbol.

food()                     // constructor to initialise food data
{
void draw_food();          // draw the food symbol X on the screen
}                          // this consists of two lines.
			   // The first line is drawn from x,y to
			   // x+size,y+size.
			   //The second line......

void draw_food()
{
}
};

//...........................................................................


void main()
{
opengraph();
creature creature1;             // constructor obtains circle centre
				// co-ordinates and circle radius.
creature1.show();               // display circle
getch();                        // wait for a keypress
//creature1.hide();               // erase the circle
//getch();
//creature1.move();               // draw circle in another position
//getch();
closegraph();                   // close the graphics screen i.e. return
				// to text mode.
}

void opengraph()
{
int graphdriver=DETECT,graphmode;
initgraph(&graphdriver,&graphmode,"c:\\tc\\bgi");
}
