//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Uloha1_misto_t.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

/*
 * 1. Definice metod tridy misto_t
 *
 */

//--------------------------------MISTO_T()-----------------------------------
misto_t::misto_t(bod_t tez, int vys, int sir, druh_t d, TColor obrys,
                 TColor vypln, String s, int mez, poloha_popisku_t pol)
    : obrys_t(tez, vys, sir), popisek(s), mezera(mez), poloha_popisku(pol)
    {
      pero = new TPen();
      pero->Color = obrys;
      pero->Mode = pmCopy;
      pero->Style = psSolid;
      stetec = new TBrush();
      stetec->Color = vypln;
      stetec->Style = bsSolid;
      switch (d) {
        case MESTO: {
          vrcholy = new bod_t[pocet_vrcholu = 8];
          vrcholy[0] = pravy_dolni();
          int pom = sirka / 3;
          vrcholy[1] = bod_t(pravy(), teziste.y);
          vrcholy[2] = bod_t(teziste.x + pom, horni());
          vrcholy[3] = bod_t(teziste.x + pom / 2, teziste.y);
          vrcholy[4] = bod_t(teziste.x - pom / 2, teziste.y);
          vrcholy[5] = bod_t(teziste.x - pom, horni());
          vrcholy[6] = bod_t(levy(), teziste.y);
          vrcholy[7] = levy_dolni(); }
        break;

        case TVRZ: {
          vrcholy = new bod_t[pocet_vrcholu = 16];
          int pom1 = sirka / 4;
          int pom2 = vyska / 4;
          vrcholy[0] = bod_t(teziste.x + pom1, dolni());
          vrcholy[1] = bod_t(teziste.x + pom1, teziste.y);
          vrcholy[2] = bod_t(pravy(), teziste.y);
          vrcholy[3] = pravy_horni();
          int pom3 = sirka / 5;
          vrcholy[4] = bod_t(pravy() - pom3, horni());
          vrcholy[5] = bod_t(pravy() - pom3, horni() + pom2);
          vrcholy[6] = bod_t(pravy() - 2* pom3, horni() + pom2);
          vrcholy[7] = bod_t(pravy() - 2* pom3, horni());
          vrcholy[8] = bod_t(levy() + 2* pom3, horni());
          vrcholy[9] = bod_t(levy() + 2* pom3, horni() + pom2);
          vrcholy[10] = bod_t(levy() + pom3, horni() + pom2);
          vrcholy[11] = bod_t(levy() + pom3, horni());
          vrcholy[12] = levy_horni();
          vrcholy[13] = bod_t(levy(), teziste.y);
          vrcholy[14] = bod_t(teziste.x - pom1, teziste.y);
          vrcholy[15] = bod_t(teziste.x - pom1, dolni()); }
        break;
      }
    }
//--------------------MISTO_T(CONST MISTO_T&)--------------------------------
misto_t::misto_t(const misto_t& m)
  : obrys_t(m.teziste, m.vyska, m.sirka), popisek(m.popisek), mezera(m.mezera),
    poloha_popisku(m.poloha_popisku)
{
  pero = new TPen();
  pero->Assign(m.pero);
  stetec = new TBrush();
  stetec->Assign(m.stetec);
  vrcholy = new bod_t[pocet_vrcholu = m.pocet_vrcholu];
  for (int i = 0; i < pocet_vrcholu; ++i) vrcholy[i] = m.vrcholy[i];
}

//--------------------~MISTO_T()---------------------------------------------
misto_t::~misto_t()
{
  delete pero;
  delete stetec;
  delete[] vrcholy;
}

//-----------------------KRESLI(TCANVAS*)------------------------------------
void misto_t::kresli(TCanvas* p_c) const
{
  //vykresleni obrazku
  p_c->Pen->Assign(pero);
  p_c->Brush->Assign(stetec);
  TPoint* p_Points = new TPoint[pocet_vrcholu];
  for (int i = 0; i < pocet_vrcholu; ++i) {
    p_Points[i].x = vrcholy[i].x;
    p_Points[i].y = vrcholy[i].y;
  }
  p_c->Polygon(p_Points, pocet_vrcholu - 1);
  //vykresleni textu
  p_c->Brush->Style = bsClear;
  p_c->Pen->Color = clBlack;
  switch (poloha_popisku) {
    case VLEVO: {
      int pom = p_c->TextWidth(popisek);
      p_c->TextOut(levy() - mezera - pom, horni(), popisek); }
    break;

    case VPRAVO:
      p_c->TextOut(pravy() + mezera, horni(), popisek);
    break;

    case NAD: {
      int pom = p_c->TextHeight(popisek);
      p_c->TextOut(levy(), horni() - mezera - pom, popisek); }
    break;

    case POD:
      p_c->TextOut(levy(), dolni() + mezera, popisek);
    break;

    default:
    break;
  } //konec switch (poloha_popisku)
}

//--------------------------MISTO_T::KRESLI_JAKO_VYBRANE(TCANVAS*)----------
void misto_t::kresli_jako_oznacene(TCanvas* p_c) const
{
  kresli(p_c);
  obrys_t::kresli(p_c);
}


