//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Uloha1_mapa_t.h"

#include "Uloha1_hex_t.h"
#include "Uloha1_HexDlg.h"
#include "Uloha1_misto_t.h"
#include "Uloha1_MistoDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

/*
 * 1. Definice metod tridy mapa_t
 *
 */

//========================1. METODY TRIDY MAPA_T=============================

/*
 *    NEFUNGUJE - vyzaduje specialni verzi kopirovaciho konstruktoru u tridy
 *                hex_t - ta je momentalne nefunkcni
 *
 *                      !!!!!!!!!!!NEMAZAT!!!!!!!!!!!!!
 *
 *
//-----------------MAPA_T::MAPA_T(TCANVAS*, INT, INT, INT)------------------
mapa_t::mapa_t(TCanvas* cc, int vv, int ss, int hh)
  : canvas(cc), pocet_hexu_na_vysku(vv), pocet_hexu_na_sirku(ss),
    hexy_iter(hexy), mista_iter(mista)
{
  //vznik prvniho hexu
  hex_t hex(hh, hh, hh);
  //dalsi hexy - podle strare metody
  for (int i = 1; i <= ss; ++i) {
    if (i % 2 == 0) { //lichy sloupec
      for (int j = 1; j <= vv; ++j) {
        hexy.na_konec(new hex_t(i * hex.sirka * 0.75,
                                j * hex.vyska + hex.vyska / 2, hex));
      }
    }
    else { //sudy sloupec
      for (int j = 1; j <= vv; ++j) {
        hexy.na_konec(new hex_t(i * hex.sirka * 0.75, j * hex.vyska, hex));
      }
    }
  }
}
*/

/*
 * Puvodni verze vytvoreni hexu - NEMAZAT !!!!! - pracuje s prvni verzi
 * specialniho konstruktoru tridy hex_t - nyni jedina funkcni
 *
 */

mapa_t::mapa_t(TCanvas* cc, int vv, int ss, const hex_t& hh)
  : canvas(cc), pocet_hexu_na_vysku(vv), pocet_hexu_na_sirku(ss),
    hiter(hexy), miter(mista)
{
  //vytvoreni hexoveho podkladu
  for (int i = 1; i <= pocet_hexu_na_sirku; ++i) {
    if (i % 2 == 0) { //lichy sloupec
      for (int j = 1; j <= pocet_hexu_na_vysku; ++j) {
        hexy.na_konec(new hex_t(i * hh.sirka * 0.75,
                                j * hh.vyska + hh.vyska / 2,
                                hh));
      }
    }
    else { //sudy sloupec
      for (int j = 1; j <= pocet_hexu_na_vysku; ++j) {
        hexy.na_konec(new hex_t(i * hh.sirka * 0.75,
                                j * hh.vyska,
                                hh));
      }
    }
  }
}

//------------------------------OZNAC(INT, INT)-------------------------------
void mapa_t::oznac(int x, int y)
  //oznaci objekt mapy - jen jeden objekt muze byt oznacen najednou
{
  if (miter.aktualni()) { //jestlize jiz je nejaky objekt vybran a na tento
                          //objekt je znovu kliknuto (viz dalsi test) je
                          //vyvolan MistoDlg - objekt lze upravit (konkretne
                          //smazu aktualni, vlozim novy a dalsi (jiz standartni
                          //cast algoritmu mi ho vybere a oznaci
    if (miter.aktualni()->jsem_tvuj_bod(x, y)) {
      if (MistoDlg->ShowModal() == mrOk) {
        misto_t* p_m = miter.vyber_aktualni();
        delete p_m;
        if (MistoDlg->PopisekCheckBox->Checked)
          mista.na_konec(new misto_t(bod_t(x, y),
                                     MistoDlg->VyskaEdit->Text.ToInt(),
                                     MistoDlg->SirkaEdit->Text.ToInt(),
                                     MistoDlg->ObrazekLB->ItemIndex,
                                     MistoDlg->ColorDlg->Color,
                                     MistoDlg->ColorDlg->Color, //stejna barva pro obrys i vypln
                                     MistoDlg->PopisekEdit->Text,
                                     MistoDlg->MezeraEdit->Text.ToInt(),
                                     MistoDlg->PopisekRG->ItemIndex + 1));
        else
          mista.na_konec(new misto_t(bod_t(x, y),
                                     MistoDlg->VyskaEdit->Text.ToInt(),
                                     MistoDlg->SirkaEdit->Text.ToInt(),
                                     MistoDlg->ObrazekLB->ItemIndex,
                                     MistoDlg->ColorDlg->Color,
                                     MistoDlg->ColorDlg->Color, //stejna barva pro obrys i vypln
                                     "", 0, misto_t::NENI));
      } //konec if (MistoDlg->ShowModal() == mrOk)
    }
    miter.obnov();
    kresli_vse(canvas);
  }
  //prochazeni mist
  while (miter()) {
    if (miter.aktualni()->jsem_tvuj_bod(x, y)) {
      miter.aktualni()->kresli_jako_oznacene(canvas);
      return;
    }
  }
  //prochazeni hexu
  while (hiter()) {
    if (hiter.aktualni()->jsem_tvuj_bod(x, y)) {
      if (HexDlg->ShowModal() == mrOk) {
        hiter.aktualni()->stetec->Color = HexDlg->ColorDlg->Color;
        kresli_vse(canvas);
        return;
      }
    }
  }
}

//-------------------------------SMAZ()---------------------------------------
void mapa_t::vymaz()
  //smaze vybrany objekt
{
  if (miter.aktualni()) {
    misto_t* p_m = miter.vyber_aktualni();
    delete p_m;
    miter.obnov();
    kresli_vse(canvas);
  }
  else Application->MessageBox("Neni vybran objekt k smazani", "Upozorneni", MB_OK);
}

//---------------------------------VLOZ_MISTO(INT, INT)----------------------
void mapa_t::vloz_misto(int x, int y)
{
  if (MistoDlg->ShowModal() == mrOk) {
    if (MistoDlg->PopisekCheckBox->Checked)
      mista.na_konec(new misto_t(bod_t(x, y),
                                 MistoDlg->VyskaEdit->Text.ToInt(),
                                 MistoDlg->SirkaEdit->Text.ToInt(),
                                 MistoDlg->ObrazekLB->ItemIndex,
                                 MistoDlg->ColorDlg->Color,
                                 MistoDlg->ColorDlg->Color, //stejna barva pro obrys i vypln
                                 MistoDlg->PopisekEdit->Text,
                                 MistoDlg->MezeraEdit->Text.ToInt(),
                                 MistoDlg->PopisekRG->ItemIndex + 1));
    else
      mista.na_konec(new misto_t(bod_t(x, y),
                                 MistoDlg->VyskaEdit->Text.ToInt(),
                                 MistoDlg->SirkaEdit->Text.ToInt(),
                                 MistoDlg->ObrazekLB->ItemIndex,
                                 MistoDlg->ColorDlg->Color,
                                 MistoDlg->ColorDlg->Color, //stejna barva pro obrys i vypln
                                 "", 0, misto_t::NENI));
    mista.konec()->kresli(canvas); //provede se vzdy, kdyz je zmakcnut OkBtn
  } //konec if (MistoDlg->ShowModal() == mrOk)
}

//-------------------------------VLOZ_POPISEK(INT, INT)----------------------
void mapa_t::vloz_popisek(int x, int y)
{
}

//---------------------------EDITUJ()----------------------------------------
void mapa_t::edituj()
  //vyvola Dialog pro vybrany objekt
{
}

//--------------------------------POSUN_DO(INT, INT)------------------------
void mapa_t::posun_do(int x, int y)
  //posune vybrany objekt na souradnice x, y
{
/*
 * NEFUNGUJE
 *
  if (miter.aktualni()) {
    miter.aktualni()->posun_do(x, y);
  }
*/
}

//-----------------------------ODOZNAC()------------------------------------
void mapa_t::odoznac()
  //odoznaci pripadne vybrane objekty
{
  miter.obnov();
}

//------------------------------KRESLI_VSE(TCANVAS*)------------------------
void mapa_t::kresli_vse(TCanvas* p_c) const
  //kresli vsechny objekty na mape
{
/*
  p_c->Brush->Color = clWhite;
  p_c->Brush->Style = bsSolid;
  p_c->Pen->Color = clWhite;
  p_c->Rectangle(0, 0,
*/
  seznam_iterator_t<hex_t> iter1(((mapa_t*) this)->hexy);
  while (iter1()) iter1.aktualni()->kresli(p_c);
  seznam_iterator_t<misto_t> iter2(((mapa_t*) this)->mista);
  while (iter2()) iter2.aktualni()->kresli(p_c);
/*
  if (miter->aktualni()) miter->aktualni()->kresli_jako_oznacene(p_c);
*/
}


/*
 *
 *   STARA VERZE - JESTE NEMAZAT
 *
 *
//--------------------OZNAC_HEX(INT, INT)------------------------------------
hex_t* mapa_t::oznac_hex(int x, int y)
  //obslouzi veskere pozadavky
{
  hexy_iter.obnov();
  while (hexy_iter()) {
    if (hexy_iter.aktualni()->jsem_tvuj_bod(x, y)) {
      if (HexDlg->ShowModal() == mrOk) {
        hexy_iter.aktualni()->stetec->Color = HexDlg->ColorDlg->Color;
        kresli_vse();
        return hexy_iter.aktualni();
      }
    }
  }
  return 0;
}

//-------------------OZNAC_MISTO(INT, INT)-----------------------------------
misto_t* mapa_t::oznac_misto(int x, int y)
  //jen oznaci misto - nastavi hexy_iter
{
  if (mista_iter.aktualni()) {
    mista_iter.aktualni()->kresli(canvas);
    mista_iter.obnov();
  }
  while (mista_iter()) {
    if (mista_iter.aktualni()->jsem_tvuj_bod(x, y)) {
//      mista_iter.aktualni()->kresli_jako_vybrany();
      return mista_iter.aktualni();
    }
  }
  return 0;
}

//---------------------VYBER_MISTO()-----------------------------------------
void mapa_t::vyber_misto()
  //vybere oznacene misto z mapy
{
}

void mapa_t::vloz_misto(misto_t* p_m)
{
  mista.na_konec(p_m->klon());
}

//----------------------VYVOLEJ_MISTODLG()-----------------------------------
void mapa_t::vyvolej_MistoDlg()
{
}

//----------------------VYVOLEJ_HEXDLG()-------------------------------------
void mapa_t::vyvolej_HexDlg()
{
}

//--------------------------MAPA_T::KRESLI_VSE()-----------------------------
void mapa_t::kresli_vse() const
{
  //vykresleni hexu
  seznam_iterator_t<hex_t> hexy_iter2(((mapa_t*) this)->hexy);
  while (hexy_iter2()) hexy_iter2.aktualni()->kresli(canvas);
  //vykresleni mist
  seznam_iterator_t<misto_t> mista_iter2(((mapa_t*) this)->mista);
  while (mista_iter2()) mista_iter2.aktualni()->kresli(canvas);
}
*/

//===========================================================================
//===========================================================================
//===========================================================================
//===========================================================================
//===========================================================================
//===========================================================================

/*
      VLOZ_OBJEKT:
        if (MistoDlg->ShowModal() == mrOk) {
          if (MistoDlg->PopisekCheckBox->Checked) {
            mapa->mista.na_konec(new misto_t(
                                     TPoint(X, Y),
                                     MistoDlg->VyskaEdit->Text.ToInt(),
                                     MistoDlg->SirkaEdit->Text.ToInt(),
                                     MistoDlg->ObrazekLB->ItemIndex,
                                     MistoDlg->ColorDlg->Color,
                                     MistoDlg->PopisekEdit->Text,
                                     MistoDlg->MezeraEdit->Text.ToInt(),
                                     MistoDlg->PopisekRG->ItemIndex + 1));
          }
          else {
            mapa->mista.na_konec(new misto_t(
                                     TPoint(X, Y),
                                     MistoDlg->VyskaEdit->Text.ToInt(),
                                     MistoDlg->SirkaEdit->Text.ToInt(),
                                     MistoDlg->ObrazekLB->ItemIndex,
                                     MistoDlg->ColorDlg->Color,
                                     "", 0, misto_t::POPISEK_NENI));
          }
          mapa->kresli_vse();
        }
      break;

      case VYBER:
        //zrus pripadny vyber
        if (mapa->oznac_misto(X, Y)) {
           mapa->mista_iter.aktualni()->kresli_jako_vybrane(mapa->canvas);
        }
        else if (mapa->oznac_hex(X,Y)) {
        }
      break;

      case ZADNY: //odoznaci objekty
        mapa->hexy_iter.obnov();
        mapa->mista_iter.obnov();
      break;

      default:
        Application->MessageBox("Neznamy pozadavek", "Zpracovani pozadavku", MB_OK);
      break;
    } //konec switch (pozadavek_uziv)
  } //konec if (pozadavek_uziv)
  else  Application->MessageBox("Pozadavek neni", "Zpracovani pozadavku", MB_OK);
*/
//===========================================================================
//===========================================================================
//===========================================================================
//===========================================================================
//===========================================================================
//===========================================================================

