//---------------------------------------------------------------------------
#ifndef Uloha1_misto_tH
#define Uloha1_misto_tH
//--------------------------------------------------------------------------

/*
 * 1. Deklarace potomka obrysu - trida misto_t
 *
 */

#include "Uloha1_obrys_t.h"

//=========================3. TRIDA MISTO_T=================================

class mapa_t; //dopredna deklarace

class misto_t: public obrys_t {
public: //verejne konstanty
  enum druh_t {
    MESTO = 0, TVRZ
  };
  enum poloha_popisku_t {
    NENI = 0, VLEVO, VPRAVO, NAD, POD
  };
protected:
  druh_t druh;
  bod_t* vrcholy; //kazdy tvar je definovan jako polygon - tato promenna
                  //uchovava souradnice jednotlivych vrcholu
  int pocet_vrcholu; //pocet vrcholu polygonu
  TPen* pero;
  TBrush* stetec;
  String popisek;
  int mezera; //mezera mezi popiskem a obrazkem
  poloha_popisku_t poloha_popisku;
public:
  //zakladni operace
  misto_t(bod_t tez, int vys, int sir, druh_t d, TColor obrys, TColor vypln,
          String s, int mez, poloha_popisku_t pol);
  misto_t(const misto_t& r_m);
  virtual ~misto_t();
  virtual misto_t* klon() const { return new misto_t(*this); }
  void kresli(TCanvas* p_c) const;
  void kresli_jako_oznacene(TCanvas* p_c) const;
  virtual rtti_t id() const { return MISTO; }
  //spratelene tridy
  friend class mapa_t;
};

#endif //Uloha1_abstr_objekt_tH
