//---------------------------------------------------------------------------
#ifndef Uloha1_obrys_tH
#define Uloha1_obrys_tH
//---------------------------------------------------------------------------

/*
 * 1. Struktur (trida) bod_t
 *
 * 2. typ rtti_t (= runtime type information) - poskytuje info o skutecnem typu
 *    objektu
 *
 * 3. Trida obrys_t - potomek dalsich objektu
 *
 */

//==============================1. STRUKTURA BOD_T===========================

struct bod_t {
  int x, y;
  bod_t(int xx = 0, int yy = 0) { x = xx; y = yy; }
  bod_t(const bod_t& b) { x = b.x; y = b.y; }
  bod_t& operator=(const bod_t& b)
  {
    if (this != &b) {
      x = b.x;
      y = b.y;
    }
    return *this;
  }
  operator TPoint ()
  {
    TPoint p;
    p.x = x;
    p.y = y;
    return p;
  }
};

//============================2. RTTI========================================

enum rtti_t {
  OBRYS = 0, MISTO, POPISEK
};

//=============================3. OBRYS_T===================================

class mapa_t; //dopredna deklarce

class obrys_t {
protected:
  bod_t teziste;
  int vyska;
  int sirka;
  //zakladni operace
  obrys_t(bod_t t, int v, int s)
    : teziste(t), vyska(v), sirka(s) { }
  obrys_t(const obrys_t& o)
    : teziste(o.teziste), vyska(o.vyska), sirka(o.sirka) { }
  obrys_t& operator=(const obrys_t& o)
  {
    if (this != &o) {
      teziste = o.teziste;
      vyska = o.vyska;
      sirka = o.sirka;
    }
    return *this;
  }
  virtual ~obrys_t() { }
  //fce vracejici polohu rohu a okraju
  int levy() const { return teziste.x - sirka / 2; }
  int pravy() const { return teziste.x + sirka / 2; }
  int horni() const { return teziste.y - vyska / 2; }
  int dolni() const { return teziste.y + vyska / 2; }
  bod_t levy_horni() const { return bod_t(teziste.x - sirka / 2, teziste.y - vyska / 2); }
  bod_t pravy_horni() const { return bod_t(teziste.x + sirka / 2, teziste.y - vyska / 2); }
  bod_t levy_dolni() const { return bod_t(teziste.x - sirka / 2, teziste.y + vyska / 2); }
  bod_t pravy_dolni() const { return bod_t(teziste.x + sirka / 2, teziste.y + vyska / 2); }
  //kreslici fce
  virtual void kresli(TCanvas* p_c) const
  {
    p_c->Pen->Mode = pmCopy;
    p_c->Pen->Style = psDot;
    p_c->Pen->Color = clBlack;
    p_c->Brush->Style = bsClear;
    p_c->Rectangle(pravy(), horni(), levy(), dolni());
  }
  void zhasni(TCanvas* p_c) const
  {
  }
  void posun_do(int x, int y)
  {
    teziste.x = x;
    teziste.y = y;
  }
  void posun_o(int x, int y)
  {
    teziste.x += x;
    teziste.y += y;
  }
  //ostatni
  virtual rtti_t id() const { return OBRYS; }
  int jsem_tvuj_bod(int x, int y)
  {
    if (x > levy() && x < pravy() && y > horni() && y < dolni()) return 1;
    return 0;
  }

  //spratelene tridy
  friend class mapa_t;
};

#endif //Uloha1_obrys_tH
