//---------------------------------------------------------------------------
#ifndef Uloha1_hex_tH
#define Uloha1_hex_tH
//---------------------------------------------------------------------------

//Uloha1_hex_t.h

/*
 * 1. Trida hex (class hex_t)
 *
 */

//============================ 1. TRIDA HEX =================================

/*
 *           0---1--------+
 *          /     \       |
 *         5   +   2      | vyska
 *         |\stred/|      |
 *         | 4---3-+------+
 *         |       |
 *         |       |
 *         +-------+
 *           sirka
 *
 * cisla indikuji poradi vrcholu
 *
 */

class mapa_t; //dopredna deklarace

class hex_t {
private:
  //atributy umisteni
  TPoint stred;
  TPoint vrcholy[6];
  int vyska;
  int sirka;
  //vlastnosti hexu
  TPen* pero;
  TBrush* stetec;
public:
  //zakladni operace
  hex_t(int x, int y, int vv);
  hex_t(const hex_t& r_hex);
  hex_t(int x, int y, const hex_t& r_hex);
    //obdoba kopirovaciho konstruktoru - ale souradnice stredu a vrcholu
    //se nastavi podle vektoru posunuti (x - posun po ose x, y - posun po ose y)
  virtual ~hex_t();
  virtual hex_t* klon() { return new hex_t(*this); }
  //ostatni
  virtual void kresli(TCanvas* c) const;
  int jsem_tvuj_bod(int x, int y) const;
  int jsem_tvuj_bod(const TPoint& r_TPoint) const
    {return jsem_tvuj_bod(r_TPoint.x, r_TPoint.y); }
  //spratelene tridy
  friend class mapa_t;
};

#endif  //Uloha1_hex_t
